#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#ifdef _WIN32
#include <direct.h>
#else
#include <unistd.h>
#endif

#include "version.h"
#include "c_console.h"
#include "c_dispatch.h"

#include "i_system.h"

#include "doomstat.h"
#include "dstrings.h"
#include "s_sound.h"
#include "g_game.h"
#include "d_items.h"
#include "p_inter.h"
#include "z_zone.h"
#include "w_wad.h"
#include "g_level.h"
#include "gi.h"
#include "r_defs.h"
#include "d_player.h"
#include "r_main.h"

extern FILE *Logfile;

CVAR (sv_cheats, "0", CVAR_SERVERINFO | CVAR_LATCH)

BOOL CheckCheatmode (void)
{
//	Printf (PRINT_HIGH, "You must run the server with '+set sv_cheats 1' to enable this command.\n");
	return true;
}

BEGIN_COMMAND (quit)
{
/*Printf (PRINT_HIGH, "Server shutting down - killing threads\n");
Printf (PRINT_HIGH, "Server is down.\n");
I_Quit();
SendMessage(GetParent(hWnd), WM_USER + 2, 0, 0);// send quit msg*/ // safe version
	exit (0);
}
END_COMMAND (quit)


EXTERN_CVAR (chasedemo)


BEGIN_COMMAND (idclev)
{
	if (CheckCheatmode ())
		return;

	if ((argc > 1) && (*(argv[1] + 2) == 0) && *(argv[1] + 1) && *argv[1])
	{
		int epsd, map;
		char buf[2];
		char *mapname;

		buf[0] = argv[1][0] - '0';
		buf[1] = argv[1][1] - '0';

		if (gameinfo.flags & GI_MAPxx)
		{
			epsd = 1;
			map = buf[0]*10 + buf[1];
		}
		else
		{
			epsd = buf[0];
			map = buf[1];
		}

		// Catch invalid maps.
		mapname = CalcMapName (epsd, map);
		if (W_CheckNumForName (mapname) == -1)
			return;

		// So be it.
		Printf (PRINT_HIGH, "%s\n", STSTR_CLEV);
      	G_DeferedInitNew (mapname);
	}
}
END_COMMAND (idclev)

BEGIN_COMMAND (changemap)
{
	if (argc > 1)
	{
		// Re-call 'map' command with same param
		char cTemp[256];
		strcpy(cTemp, "map ");
		strcpy(cTemp + strlen("map "), argv[1]);
		AddCommandString(cTemp);
	}
	else
	{
		Printf (PRINT_HIGH, "Syntax: changemap mapname\n");
	}
}
END_COMMAND (changemap)

BEGIN_COMMAND (gameversion)
{
	Printf (PRINT_HIGH, "%d.%d : " __DATE__ "\n", VERSION / 100, VERSION % 100);
}
END_COMMAND (gameversion)

BEGIN_COMMAND (exec)
{
	FILE *f;
	char *cmd = 0;
	int l;

	if (argc < 2)
		return;

	if(!strlen(argv[1]))
		return;

	if(strlen(argv[1]) == 2)
	{
		if(argv[1][0] == '\"' && argv[1][1] == '\"')
			return;
	}
	
	f = fopen (argv[1], "rt");

	if(f)
	{
		fseek(f, 0, SEEK_END);
		l = ftell(f);
		fseek(f, 0, SEEK_SET);

		cmd = new char[l + 1];
		cmd[0] = 0;

		while(fgets (cmd, l, f))
		{
			AddCommandString (cmd);
		}

		fclose (f);

		if(cmd)
			delete[] cmd;
	}
	else
		Printf (PRINT_HIGH, "Could not open \"%s\"\n", argv[1]);
}
END_COMMAND (exec)

BEGIN_COMMAND (dumpheap)
{
	int lo = PU_STATIC, hi = PU_CACHE;

	if (argc >= 2) {
		lo = atoi (argv[1]);
		if (argc >= 3) {
			hi = atoi (argv[2]);
		}
	}

	Z_DumpHeap (lo, hi);
}
END_COMMAND (dumpheap)

BEGIN_COMMAND (logfile)
{
	time_t clock;
	char *timestr;

	time (&clock);
	timestr = asctime (localtime (&clock));

	if (Logfile)
	{
		Printf (PRINT_HIGH, "Log stopped: %s\n", timestr);
		fclose (Logfile);
		Logfile = NULL;
	}

	if (argc >= 2)
	{
		if ( (Logfile = fopen (argv[1], "w")) )
		{
			Printf (PRINT_HIGH, "Log started: %s\n", timestr);
		}
		else
		{
			Printf (PRINT_HIGH, "Could not start log\n");
		}
	}
}
END_COMMAND (logfile)

BOOL P_StartScript (AActor *who, line_t *where, int script, char *map, int lineSide,
					int arg0, int arg1, int arg2, int always);

BEGIN_COMMAND (puke)
{
	if (argc < 2 || argc > 5) {
		Printf (PRINT_HIGH, " puke <script> [arg1] [arg2] [arg3]\n");
	} else {
		int script = atoi (argv[1]);
		int arg0=0, arg1=0, arg2=0;

		if (argc > 2) {
			arg0 = atoi (argv[2]);
			if (argc > 3) {
				arg1 = atoi (argv[3]);
				if (argc > 4) {
					arg2 = atoi (argv[4]);
				}
			}
		}
		P_StartScript (m_Instigator, NULL, script, level.mapname, 0, arg0, arg1, arg2, false);
	}
}
END_COMMAND (puke)

BEGIN_COMMAND (error)
{
	char *text = BuildString (argc - 1, argv + 1);
	char *textcopy = copystring (text);
	delete[] text;
	I_Error (textcopy);
}
END_COMMAND (error)

BEGIN_COMMAND (dir)
{
	char dir[256], curdir[256];
	char *match;
	findstate_t c_file;
	long file;

	if (!getcwd (curdir, 256))
	{
		Printf (PRINT_HIGH, "Current path too long\n");
		return;
	}

	if (argc == 1 || chdir (argv[1]))
	{
		match = argc == 1 ? (char *)"./*" : argv[1];

		ExtractFilePath (match, dir);
		if (dir[0])
		{
			match += strlen (dir);
		}
		else
		{
			dir[0] = '.';
			dir[1] = '/';
			dir[2] = '\0';
		}
		if (!match[0])
			match = "*";

		if (chdir (dir))
		{
			Printf (PRINT_HIGH, "%s not found\n", dir);
			return;
		}
	}
	else
	{
		match = "*";
		strcpy (dir, argv[1]);
		if (dir[strlen(dir) - 1] != '/')
			strcat (dir, "/");
	}

	if ( (file = I_FindFirst (match, &c_file)) == -1)
		Printf (PRINT_HIGH, "Nothing matching %s%s\n", dir, match);
	else
	{
		Printf (PRINT_HIGH, "Listing of %s%s:\n", dir, match);
		do
		{
			if (I_FindAttr (&c_file) & FA_DIREC)
				Printf_Bold ("%s <dir>\n", I_FindName (&c_file));
			else
				Printf (PRINT_HIGH, "%s\n", I_FindName (&c_file));
		} while (I_FindNext (file, &c_file) == 0);
		I_FindClose (file);
	}

	chdir (curdir);
}
END_COMMAND (dir)
